module.exports = function(grunt){
	grunt.initConfig({
		config: {
			'src' : "src",
			'dist' : "dist",
			'test' : "test",
		},

		browserify: {
			files: {
				src: "<%= config.src %>/index.js",
				dest: "<%= config.dist %>/bacon.js",
			},
		},

		watch: {
			dist: {
				files: ['<%= config.src %>/**/*.js'],
				tasks: ['browserify'],
			},
			docs: {
				files: ['<%= config.src %>/**/*.js'],
				tasks: ['jsdoc'],
			}
		},

		jshint: {
			files: ['<%= config.src %>/**/*.js'],
		},

		mochaTest: {
			test: {
				src: ['<%= config.test %>/**/*.js'],
			}
		},

		jsdoc: {
			dist: {
				src: ['<%= config.src %>/**/*.js'],
				options: {
					destination: 'docs',
				}
			}
		},
	});

	grunt.loadNpmTasks("grunt-browserify");
	grunt.loadNpmTasks("grunt-contrib-watch");
	grunt.loadNpmTasks("grunt-contrib-jshint");
	grunt.loadNpmTasks("grunt-mocha-test");
	grunt.loadNpmTasks("grunt-jsdoc");

	grunt.registerTask('build', ['jshint', 'browserify']);
	grunt.registerTask('test', ['jshint', 'mochaTest']);
};
