var isInt = require('is-integer');
var extend = require('extend');
var Graph;
/**
 * autocreate function
 * @function
 * @param {Array|Object} data - Graph data to create one graph (Array) or multiple graphs (Object)
 * @param {Object} [options]
 * @param {Bool} [options.directed=false] - Create directed edges
 * @returns {Graph|Object} Graph created or an object containing multiple Graphs
 */
var autocreate = module.exports = function(data, options){
	Graph = require('./graph.js');
	options = extend({
		directed: false,
	}, options);

	var isArray = (data instanceof Array);
	if(!(data instanceof Object)){ //an array _is_ an Object instance
		throw new Error("autocreate expects an array or object");
	}

	var returnData = {};

	if(isArray){
		data = {'graph' : data};
	}

	for(var key in data){
		var graph = new Graph();
		var graphData = data[key];

		var i;
		var node;
		var nodeData;
		for(i=0; i<graphData.length; i++){
			nodeData = graphData[i];
			if(nodeData instanceof Array){
				node = graph.addNode();
			}else{
				//check if nodeData is object and create a complex node
			}
		}

		for(i=0; i<graphData.length; i++){
			node = graph.getNode(i);
			nodeData = graphData[i];
			var edgesData;
			if(nodeData instanceof Array){
				edgesData = nodeData;
			}else{
				//check if nodeData is object and use the edges property
				edgesData = nodeData.edges;
			}

			if(!(edgesData instanceof Array)){
				throw new Error("list of edges must be an array");
			}
			for(var j=0; j<edgesData.length; j++){
				var edgeData = edgesData[j];
				if(isInt(edgeData)){
					//integer found, connect current node to node at int index
					var endNode = graph.getNode(edgeData);
					if(!endNode){
						throw new Error("no node found at index " + edgeData);
					}
					node.addEdge(graph.getNode(edgeData), !!options.directed);
				}else{
					//edge is complex type, make a complex edge
				}
			}
		}
		returnData[key] = graph;
	}
	return (isArray) ? returnData.graph : returnData;
};
