var Edge, Node;
/**
 * HalfEdge object represents half of an edge, and therefore only has one weight
 * @constructor
 * @param {Edge} edge - the full Edge object which relates to this HalfEdge
 * @param {Node} toNode - node that this HalfEdge points towards
 */
var HalfEdge = module.exports = function(edge, toNode){
	Edge = require('./edge.js');
	Node = require('./node.js');
	if(!(this instanceof HalfEdge)){
		return new HalfEdge(edge, toNode);
	}

	if(!(edge instanceof Edge && toNode instanceof Node)){
		throw new Error("first two arguments to HalfEdge contructor must be Edge and Node objects");
	}

	(function(){
		this.start = edge.getNeighbourByNode(toNode);
		this.end = toNode;
		this.weight = edge.getWeightToNode(toNode);
	}).call(this);

};
